#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>
#include <unistd.h>
#include <sys/wait.h>
#include <signal.h>
#include <errno.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>

#include <asm/pie.h>

typedef struct
{
	char *	name;
	char *	value;
} Alias;

void childProcess (char *cmd);
Alias *findAlias (char *name);

void sigchild (int signo)
{
  int status;

  while (waitpid(-1, &status, WNOHANG) > 0);
  signal(SIGCHLD, sigchild);
}

int system (const char * command)
{
  char *cmd;
  char *filep;
  int pid;
  Alias *alias;
  int redirect = 0;
  int fd;
  int status;
  int i;
  char *w,*w2;

  cmd = strchr (command, '>');
  if (cmd) {
    w2 = cmd;
    cmd ++;
    while (isblank (*cmd)) cmd ++;
    if (*cmd == '&') {
      redirect = 2;
      cmd ++;
      while (isblank (*cmd)) cmd ++;
    }
    else {
      redirect = 1;
    }
    w = cmd;
    while (isalnum (*cmd) || *cmd == '/') cmd ++;
    if (*cmd != '\0') {
      *cmd = '\0';
      cmd ++;
      cmd = strchr (command, '&');
      if (cmd) {
	*w2 = '&';
      }
      else {
	*w2 = '\0';
      }
    }
    else {
      *w2 = '\0';
    }
    filep = (char *) malloc (strlen(w)+1);
    strcpy(filep, w);
  }

  cmd = strrchr (command, '&');
  if (cmd) {
    cmd --;
    while (isblank (*cmd)) cmd --;
    *(cmd + 1) = '\0';
  }
  for (i = 0; command[i] != '\0'; i++) {
    if (isblank (command[i])) break;
  }
  if (command[i] == '\0') {
    if (alias = findAlias(command)) {
      strcpy (command, alias->value);
    }
  }
  if (cmd) {
    signal (SIGCHLD, sigchild);
  }

  pid = fork ();
  if (pid == 0) {
    if (redirect) {
      fd = open (filep, O_WRONLY|O_CREAT|O_TRUNC, 0666);
      dup2 (fd, 1);
      if (redirect == 2) {
	dup2 (fd, 2);
      }
      close (fd);
    }
    childProcess (command);
    if (!cmd) {
      status = 0;
      while (((pid = waitpid(pid, &status, 0)) < 0) && (errno == EINTR)) ;
      if (pid < 0) {
	fprintf(stderr, "Error from waitpid: %s", strerror(errno));
	return;
      }
      if (WIFSIGNALED(status)) {
	fprintf(stderr, "pid %ld: killed by signal %d\n",
		(long) pid, WTERMSIG(status));
      }
    }
  }
}

void
do_suspend(int argc, const char ** argv)
{
  int fd;

  fputc('\n', stdout);
  fd = open("/dev/pie", O_RDWR);
  ioctl(fd, PIE_IOCENABLEKDB, 0);
  close(fd);
}
